import React from 'react';
import classnames from 'classnames';
import { parseMetadata, suffixMetadata } from '@highlight-ui/utils-commons';
import { InlineNotification } from '@highlight-ui/inline-notification';
import { Heading, Body } from '@highlight-ui/typography';
import { Button } from '@highlight-ui/button';
import { Icon } from '@highlight-ui/icon';
import { Stack } from '@highlight-ui/layout';

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
function __awaiter(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
}
function __generator(thisArg, body) {
  var _ = {
      label: 0,
      sent: function () {
        if (t[0] & 1) throw t[1];
        return t[1];
      },
      trys: [],
      ops: []
    },
    f,
    y,
    t,
    g;
  return g = {
    next: verb(0),
    "throw": verb(1),
    "return": verb(2)
  }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
    return this;
  }), g;
  function verb(n) {
    return function (v) {
      return step([n, v]);
    };
  }
  function step(op) {
    if (f) throw new TypeError("Generator is already executing.");
    while (g && (g = 0, op[0] && (_ = 0)), _) try {
      if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
      if (y = 0, t) op = [op[0] & 2, t.value];
      switch (op[0]) {
        case 0:
        case 1:
          t = op;
          break;
        case 4:
          _.label++;
          return {
            value: op[1],
            done: false
          };
        case 5:
          _.label++;
          y = op[1];
          op = [0];
          continue;
        case 7:
          op = _.ops.pop();
          _.trys.pop();
          continue;
        default:
          if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
            _ = 0;
            continue;
          }
          if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
            _.label = op[1];
            break;
          }
          if (op[0] === 6 && _.label < t[1]) {
            _.label = t[1];
            t = op;
            break;
          }
          if (t && _.label < t[2]) {
            _.label = t[2];
            _.ops.push(op);
            break;
          }
          if (t[2]) _.ops.pop();
          _.trys.pop();
          continue;
      }
      op = body.call(thisArg, _);
    } catch (e) {
      op = [6, e];
      y = 0;
    } finally {
      f = t = 0;
    }
    if (op[0] & 5) throw op[1];
    return {
      value: op[0] ? op[1] : void 0,
      done: true
    };
  }
}
var styles = {
  "emptyStateContainer": "EmptyState-module__UlWpv8Ai__v7-3-0",
  "emptyStateIcon": "EmptyState-module__LUH-LWQB__v7-3-0",
  "emptyStateTitle": "EmptyState-module__yzA04s--__v7-3-0",
  "emptyStateDescription": "EmptyState-module__8DRtEs6z__v7-3-0",
  "iconEmptyStateDescription": "EmptyState-module__ptIVD7mH__v7-3-0",
  "retryButton": "EmptyState-module__RjNnsxoD__v7-3-0",
  "imageEmptyStateDescription": "EmptyState-module__h6Xzlonv__v7-3-0",
  "emptyStateCustomImage": "EmptyState-module__XmDdnTNE__v7-3-0"
};
function EmptyStateWithRef(_a, ref) {
  var _b;
  var _this = this;
  var className = _a.className,
    description = _a.description,
    _c = _a.iconColor,
    iconColor = _c === void 0 ? 'icon-default' : _c,
    _d = _a.iconFamily,
    iconFamily = _d === void 0 ? 'solid' : _d,
    _e = _a.iconName,
    iconName = _e === void 0 ? 'exclamation-square' : _e,
    _f = _a.iconSize,
    iconSize = _f === void 0 ? 26 : _f,
    metadata = _a.metadata,
    onRetryButtonClick = _a.onRetryButtonClick,
    _g = _a.retryButtonText,
    retryButtonText = _g === void 0 ? 'Retry' : _g,
    _h = _a.retryButtonVariant,
    retryButtonVariant = _h === void 0 ? 'emphasized' : _h,
    _j = _a.copyTraceIdToClipboardButtonText,
    copyTraceIdToClipboardButtonText = _j === void 0 ? 'Copy to clipboard' : _j,
    _k = _a.copyTraceIdToClipboardNotificationText,
    copyTraceIdToClipboardNotificationText = _k === void 0 ? 'Copied to clipboard' : _k,
    _l = _a.showRetryButton,
    showRetryButton = _l === void 0 ? false : _l,
    _m = _a.title,
    title = _m === void 0 ? 'This is an empty state' : _m,
    _o = _a.customImage,
    customImage = _o === void 0 ? '' : _o,
    _p = _a.customImageClassName,
    customImageClassName = _p === void 0 ? '' : _p,
    traceId = _a.traceId;
  var containerClassName = classnames(styles.emptyStateContainer, className);
  var onCopyToClipboardButtonClick = function () {
    return __awaiter(_this, void 0, void 0, function () {
      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            if (!traceId) return [3 /*break*/, 2];
            return [4 /*yield*/, navigator.clipboard.writeText(traceId)];
          case 1:
            _a.sent();
            _a.label = 2;
          case 2:
            return [2 /*return*/];
        }
      });
    });
  };

  return /*#__PURE__*/React.createElement("div", __assign({}, parseMetadata(metadata), {
    className: containerClassName,
    ref: ref
  }), customImage ? /*#__PURE__*/React.createElement("img", __assign({
    src: customImage,
    className: classnames(styles.emptyStateCustomImage, customImageClassName),
    alt: "empty state"
  }, parseMetadata(suffixMetadata(metadata, 'custom-image')))) : /*#__PURE__*/React.createElement(Icon, __assign({
    className: styles.emptyStateIcon,
    name: iconName,
    color: iconColor,
    size: iconSize,
    type: iconFamily
  }, parseMetadata(suffixMetadata(metadata, 'icon')))), /*#__PURE__*/React.createElement("div", {
    className: styles.emptyStateTitle
  }, /*#__PURE__*/React.createElement(Heading, {
    variant: customImage ? 'xlarge' : 'small',
    as: "span",
    color: "text-default"
  }, title)), /*#__PURE__*/React.createElement(Stack, {
    space: "spacing-4",
    className: classnames(styles.emptyStateDescription, (_b = {}, _b[styles.iconEmptyStateDescription] = customImage === '', _b[styles.imageEmptyStateDescription] = customImage !== '', _b))
  }, description, traceId && /*#__PURE__*/React.createElement(Stack, null, /*#__PURE__*/React.createElement(Body, {
    as: "p",
    metadata: suffixMetadata(metadata, 'trace-id')
  }, "Trace id: ", traceId), /*#__PURE__*/React.createElement(InlineNotification, {
    placement: "bottom",
    notificationMessage: /*#__PURE__*/React.createElement(Body, null, copyTraceIdToClipboardNotificationText)
  }, /*#__PURE__*/React.createElement(Button, {
    variant: "plain",
    onClick: onCopyToClipboardButtonClick,
    metadata: suffixMetadata(metadata, 'copy-to-clipboard-btn'),
    icon: "clipboard"
  }, copyTraceIdToClipboardButtonText)))), showRetryButton && /*#__PURE__*/React.createElement(Button, {
    className: styles.retryButton,
    variant: retryButtonVariant,
    onClick: onRetryButtonClick,
    metadata: suffixMetadata(metadata, 'retry-btn')
  }, retryButtonText));
}
EmptyStateWithRef.displayName = 'EmptyState';
var EmptyState = /*#__PURE__*/React.forwardRef(EmptyStateWithRef);
var EmptyState$1 = /*#__PURE__*/React.memo(EmptyState);
export { EmptyState$1 as EmptyState };
//# sourceMappingURL=index.js.map
